import os, time, json


# 获取cookies的存储路径
def get_cookies_dir():
    project_path = os.path.dirname(os.getcwd())
    file_path = project_path + "/cookies/"
    if not os.path.exists(file_path):
        os.mkdir(file_path)
    return file_path


# print(get_cookies_dir())


# 获取并且保存cookies
def save_cookies(driver):
    file_path = get_cookies_dir()
    # 保存cookies到文件中
    cookies = driver.get_cookies()
    with open(file_path + 'jd.cookies', 'w') as c:
        c.write(json.dumps(cookies))


def check_cookies(driver):
    # 设置一个登录状态,初始值是未登录
    login_status = False
    # 讲cookies信息保存到driver中
    driver = save_cookies_to_driver(driver)

    # 进行跳转链接的检测
    driver.get("https://order.jd.com/center/list.action")
    current_url = driver.current_url
    if current_url == 'https://order.jd.com/center/list.action':
        login_status = True
        print("登录成功,cookies验证通过")
        return login_status
    else:
        print("登录失败")
        return login_status


# 保存cookies信息到driver中
def save_cookies_to_driver(driver):
    cookies_file = get_cookies_file()
    jd_cookies_file = open(cookies_file, "r")
    jd_cookies_str = jd_cookies_file.readline()
    jd_cookies_dict = json.loads(jd_cookies_str)

    # 这里必须清除旧的cookies
    driver.get("https://www.jd.com")
    driver.delete_all_cookies()

    for cookie in jd_cookies_dict:
        driver.add_cookie(cookie)
    return driver


# 获取保存cookies文件
def get_cookies_file():
    return get_cookies_dir() + "jd.cookies"
