# 二叉搜索树的最近公共祖先


# 思路:
# 题目中给出是一个二叉搜索树。二叉搜索树中根节点总是比左子树上的每一个数大，总是比右子树每一个数小。
# 因此p和q的公共祖先的值应该介于左子树和右子树之间。从根节点开始遍历，如果根节点的数值均小于p和q的数值，
# 那么代表p和q 的祖先在根节点的右子树中。如果根节点的数值均大于p和q的数值，那么代表p和q 的祖先在根节点的左子树中。
# 若不满足上述，就代表祖先节点就是pq中靠近根节点的一个。
class TreeNode:
    def __init__(self, x):
        self.val = x
        self.left = None
        self.right = None
class Solution:
    def lowestCommonAncestor(self, root, p, q):
        """
                :type root: TreeNode
                :type p: TreeNode
                :type q: TreeNode
                :rtype: TreeNode
                """
        if root == None:
            return None
        if (root.val > p.val and root.val > q.val) or (root.val < p.val and root.val < q.val):
            return root
        if root.val > p.val and root.val > q.val:
            return self.lowestCommonAncestor(root.left,p,q)
        if p.val > root.val and q.val > root.val:
            return self.lowestCommonAncestor(root.right,p,q)
        return root

if __name__ == '__main__':
    s = Solution()


# 思路 :
# 当前结点等于q或者p，那么该结点必为公共结点
# 由于二叉搜索数左小右大的特定，判断当前结点的值与p和q的大小关系，假设p的值比q大。如果当前结点值满足q<value<p，当前结点必为公共结点
# value>p，二叉树向下遍历左子树
# value<q，二叉树向下遍历右子树
class Solution:
    def lowestCommonAncestor(self, root, p, q):
        """
                :type root: TreeNode
                :type p: TreeNode
                :type q: TreeNode
                :rtype: TreeNode
        #         """
        # if p.val < q.val:  # p大，q小
        #     p, q = q, p
        # while root:
        #     # if root == p or root == q:
        #     #     return root
        #     # if root.val < p.val and root.val > q.val:
        #     #     return root
        #     if root.val < q.val:
        #         root = root.right
        #     if root.val > p.val:
        #         root = root.left
        #     else:  # 该句else等价于上面被注释掉的四句
        #         return root